# Copyright (c) 1991, 1992, 1993 Brad Eacker,
#              (Music, Intuition, Software, and Computers)
# All Rights Reserved

.IFDEF __VAX__
OPTIONS=,VAXCOPTS/OPTION
.ELSE
OPTIONS
.ENDIF

# if you don't have alloca uncomment the next lines
#ALLOCA=/Define=("alloca=malloc")
#ALLOCA_OBJ=,alloca.obj

# if u_char is already defined in your system uncomment the following
#EX_FLAGS=-DUCHAR

# if you need to use bison uncomment the following
#YACC=bison -y
YACC=yacc

CFLAGS=/Optimize $(ALLOCA) $(EX_FLAGS)
YFLAGS=-d

#SHELL=/bin/sh

TARGETS = dbflst.exe,	-
	  tmpl.exe,	-
	  dbfadd.exe,	-
	  dbfdel.exe,	-
	  dbfpack.exe,	-
	  dbfget.exe,	-
	  dbfndx.exe,	-
	  dbfcreat.exe

THINGS  = tmpl.dbf
TEST_TARGS = dbftst.exe, lexi.exe, gram.exe

DBF_SRCS = dbf.h, dbf_head.c, dbf_rec.c, dbf_misc.c, dbftst.c, dbflst.c,  -
	token.l, gram.y, dbinter.c, dbf_sym.h, yyerr.c, tmpl.c, dbfadd.c, -
	dbfdel.c, dbfpack.c, dbfget.c, dbf_ndx.h, dbf_ndx.c, dbfndx.c, 	  -
	dbfcreat.c

DBF_OBJS = dbf_head.obj, -
	   dbf_rec.obj,  -
	   dbf_misc.obj, -
	   dbf_ndx.obj,  -
	   strdup.obj,   -
	   getopt.obj

OBJS = dbinter.obj $(ALLOCA_OBJ)


all : $(TARGETS), $(THINGS)

test : $(TEST_TARGS)

everything : all test

extras : tmpl.dbf

dbftst.exe : dbftst.obj $(DBF_OBJS)
	Link /Exec=$@ dbftst.obj, $(DBF_OBJS) $(OPTIONS)

dbflst.exe : dbflst.obj $(DBF_OBJS)
	Link /Exec=$@ dbflst.obj, $(DBF_OBJS) $(OPTIONS)

lexi.exe : lexyy.c
	$(CC) $(CFLAGS) /Define=DEBUG lexyy.c
	Link /Exec=$@ lexyy $(OPTIONS)

gram.exe : gram_tab.c lexyy.c yyerr.obj $(OBJS)
	$(CC) $(CFLAGS) /Define=YYDEBUG gram_tab.c,lexyy.c
	Link /Exec=$@ yyerr.obj, lexyy.obj, gram_tab.obj, $(OBJS) $(OPTIONS)

tmpl.dbf : tmpl.exe
	Run []tmpl.exe

tmpl.exe : tmpl.obj $(DBF_OBJS)
	Link /Exec=$@ tmpl.obj, $(DBF_OBJS) $(OPTIONS)

dbfadd.exe : dbfadd.obj $(DBF_OBJS)
	Link /Exec=$@ dbfadd.obj, $(DBF_OBJS) $(OPTIONS)

dbfdel.exe : dbfdel.obj $(DBF_OBJS)
	Link /Exec=$@ dbfdel.obj, $(DBF_OBJS) $(OPTIONS)

dbfpack.exe : dbfpack.obj $(DBF_OBJS)
	Link /Exec=$@ dbfpack.obj, $(DBF_OBJS) $(OPTIONS)

dbfget.exe : dbfget.obj $(DBF_OBJS)
	Link /Exec=$@ dbfget.obj, $(DBF_OBJS) $(OPTIONS)

dbfcreat.exe : dbfcreat.obj $(DBF_OBJS)
	Link /Exec=$@ dbfcreat.obj, $(DBF_OBJS) $(OPTIONS)

dbfndx.exe : dbfndx.obj $(DBF_OBJS)
	Link /Exec=$@ dbfndx.obj, $(DBF_OBJS) $(OPTIONS)

lexyy.c : token.l
	lex token.l

gram_tab.c : gram.y
	$(YACC) $(YFLAGS) gram.y
	rename y_tab.c gram_tab.c
	rename y_tab.h gram_tab.h
#
#	if [ -f y_tab.c ] ; then 	\
#		mv y_tab.c gram_tab.c; 	\
#		mv y_tab.h gram_tab.h; 	\
#	fi

#shar :
#	shar README $(DBF_SRCS) Makefile HISTORY >dbf.shar

clean :
	@ Delete *.obj;
	@ Delete lexyy.c;
	@ Delete y_tab.*;
	@ Delete y.output;
	@ Delete gram_tab.*;
	@ Delete errs.;
	@ Delete output;
	@ Delete tg.out;
#	rm -f *.obj lexyy.c y_tab.[ch] y.output gram_tab.[ch]
#	rm -f errs output *~ tg.out

clobber : clean
#	rm -f $(TEST_TARGS) $(TARGETS) $(THINGS)

dbf_head.obj : dbf.h dbf_head.c
dbf_rec.obj  : dbf.h dbf_rec.c
dbf_misc.obj : dbf.h dbf_misc.c
dbf_ndx.obj  : dbf.h dbf_ndx.h dbf_ndx.c
yyerr.obj    : yyerr.c
dbinter.obj  : dbinter.c
dbflst.obj   : dbf.h dbflst.c
dbftst.obj   : dbf.h dbftst.c
dbfadd.obj   : dbf.h dbfadd.c
dbfdel.obj   : dbf.h dbfdel.c
dbfpack.obj  : dbf.h dbfpack.c
dbfget.obj   : dbf.h dbfget.c
dbfndx.obj   : dbf.h dbf_ndx.h dbfndx.c
tmpl.obj     : dbf.h tmpl.c
strdup.obj   : strdup.c
getopt.obj   : getopt.c
